# How-tos

Here you can find step-by-step tutorials covering IDA's debugging capabilities across different platforms, targets, and workflows.

## Local debugging

**Windows:**

* [Debugging a Windows executable locally and remotely](/core/debugger/tutorials/debugger_windows_local.md)
* [Windows Local Debugging](/core/debugger/tutorials/win_local.md)
* [Debugging Windows Applications with IDA WinDbg Plugin](/core/debugger/tutorials/windbg_tut.md)

**Linux:**

* [Debugging Linux Applications locally](/core/debugger/tutorials/debugger_linux_local.md)

**macOS:**

* [Debugging Mac OSX Applications with IDA Pro](/core/debugger/tutorials/mac_debugger_primer2.md)

***

## Remote debugging

* [Remote debugging with IDA Pro](/core/debugger/tutorials/remote-debugging-with-ida-pro.md) — general guide to setting up and using IDA's remote debugger servers across platforms.
* [Linux to Win64 Debugging](/core/debugger/tutorials/linuxtowin64.md)
* [Windows to Linux Debugging](/core/debugger/tutorials/wintolinux.md)
* [Debugging Linux/Windows Applications with PIN Tracer module](/core/debugger/tutorials/debugger_pin.md)

***

## iOS and Android

* [Debugging iOS Applications with IDA Pro](/core/debugger/tutorials/ios_debugger_primer2.md)
* [Debugging iOS Applications using CoreDevice (iOS 17 and up)](/core/debugger/tutorials/ios_debugging_coredevice.md)
* [Debugging Dalvik Programs](/core/debugger/tutorials/debugger_dalvik.md)

***

## Kernel debugging

* [Debugging Windows Kernel with VMWare and IDA WinDbg Plugin](/core/debugger/tutorials/debugger_windbg_kernel.md)
* [Debugging the XNU Kernel with IDA Pro](/core/debugger/tutorials/xnu_debugger_primer.md)

***

## Specialized topics

* [Trace Replayer and Managing Traces](/core/debugger/tutorials/trace_replayer.md) — recording, replaying, comparing, and diffing execution traces.
* [Appcall](/core/debugger/tutorials/appcall_primer.md) — calling application functions directly from IDA scripts using IDC or IDAPython.
* [Debugging code snippets with QEMU debugger](/core/debugger/tutorials/primer.md) — emulator-based debugging for code snippets and shellcode.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hex-rays.com/core/debugger/tutorials.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
